/* Rexx program to test access to the class 'datergf.DateTimeRGF'

   Make sure that *this* directory is in your %CLASSPATH%, otherwise
   the program cannot find the Java "datergf"-package (subdirectory of this one)*/

dt_class = "datergf.DateTimeRGF"

dt1 = bsf("registerBean", "", dt_class) /* create and get a DateTimeRGF object  */
say bsf("invoke", dt1, "toString")      /* show its value                       */

call bsf "invoke", dt1, "update"        /* set to now                           */
say bsf("invoke", dt1, "toString")      /* show the values                      */
say

i=3
say "now sleeping for" i "seconds ..."
call bsf 'sleep', i                     /* sleep i seconds using bsf4rexx       */

call bsf "invoke", dt1, "update"        /* set to now                           */
say bsf("invoke", dt1, "toString")      /* show the values                      */

say
date1 = bsf("getFieldValue", dt1, "date")       /* get DateRGF field            */
say "date-portion:" bsf("invoke", date1,  "toString")

                                        /* determine ISO-week, using a public static
                                           field of the interface "DTC"         */
week=bsf("invoke", date1, "get", "i", bsf("getStaticValue", "datergf.DTC", "WEEK")  )
say "today falls into ISO-week #" week
say

time1 = bsf("getFieldValue", dt1, "time")       /* get TimeRGF field            */
say "time-portion:" bsf("invoke", time1,  "toString")
say

easter = bsf("invoke", date1, "easter", "o", date1)     /* get Easter sunday for this year      */
week=bsf("invoke", easter, "get", "i", bsf("getStaticValue", "datergf.DTC", "WEEK")  )
say "This year Easter sunday is:" bsf("invoke", easter, "toString") "which is ISO-week #" week
say

say "---"
say

say "This demos the Java class 'DateFormatRGF':"
say
say "   the format string being used is:"
say

formatString="'Today is:' [EEEE], d. [MMM] yyyy, 'day #:' D (g 'to go'), hh:mm:ss.SSS [a]"
say formatString
say


df = bsf("registerBean", "", "datergf.DateFormatRGF")   /* get an instance of the dateformatter */

say bsf("invoke", df, "format", "str", formatString, "obj", dt1)
say "   ---"
say "   (now localizing the names of the months and days as well as the 'am/pm')"
call bsf "invoke", df, "localize"
say bsf("invoke", df, "format", "str", formatString, "obj", dt1)
say "   the default formatting now produces:" '[' || bsf("invoke", dt1, "toString") || ']'
say "---"
say
say "Please press enter to continue..."
parse pull answer

locales.1="ITALIAN"
locales.2="FRENCH"
locales.3="UK"
locales.4="US"
locales.5="JAPANESE"
locales.0=5     /* indicate # of elements in stem ("hash")      */

do i=1 to locales.0
   say "trying to get the" locales.i "Locale from Java ("i "of" locales.0") ..."
   call bsf "invoke", df, "localize", "obj", bsf("getStaticValue", "java.util.Locale", locales.i)
   say bsf("invoke", df, "format", "str", formatString, "obj", dt1)
   say "   the default formatting now produces:" '[' || bsf("invoke", dt1, "toString") || ']'
   say "---"
end

say
say "More on the Java package 'datergf' can be found at:"
say
say "   http://nestroy.wi-inf.uni-essen.de/Forschung/rgf/datergf/"
say
say "or check the Internet starting with:"
say
say "   http://www.RexxLA.org"

