/*
   Name:    "HelloWorld.rex"

   Invoke:  "java com.ibm.bsf.Main -lang rexx -in HelloWorld.rex"
                or
            "java com.ibm.bsf.Main            -in HelloWorld.rex"

   Purpose:  create a window with a choice-object and two text-fields and buttons;
             if the ok-button is pressed then popup another window and display what
             was chosen and entered.

             This version stresses Object Rexx and the wrapper class "BSF.cls" which
             makes Java look like if it was Object Rexx ...
             ;)

   Needs:    IBM's "Bean Scripting Framework" (BSF)
             (cf. "http://oss.software.ibm.com/developerworks/projects/bsf")

             and the package "bsf4rexx"
             (cf. "http://nestroy.wi-inf.uni-essen.de/Forschung/rgf/Entwicklung.html")

   Date:    2001-04-18

   Author:   Rony G. Flatscher, University of Essen, WU Wien University,
             derived from Peter Kalender's work for the "Essener Ski Seminar",
             University of Essen (Oct 2000 to Feb 2001)
             (cf. "http://nestroy.wi-inf.uni-essen.de/Lv/seminare/ws0001/index-e.html");
*/

        /* create a Java awt window and a Java awt button       */
window = BSF( 'registerBean', '', 'java.awt.Frame' , 'String', '*** Hello World! ***' )
button = BSF( 'registerBean', '', 'java.awt.Button', 'String', 'Press me!' )

        /* prepare window and show it   */
call BSF 'invoke', Window, 'add', 'O', Button
call BSF 'invoke', Window, 'pack'
call BSF 'invoke', Window, 'show'
call BSF 'invoke', Window, 'toFront'

        /* now let Java notify us of the following events, sending us the defined string*/
call BSF 'addEventListener', Window, 'window', 'windowClosing', 'call BSF "exit"'
call BSF 'addEventListener', Button, 'action', '',              'call BSF "exit"'

        /* run the event loop, otherwise this instance of Rexx gets shut down   */
        /* dispatch the strings received as a result of the registered events   */
do forever
     res=BSF("pollEventText")
     say "(in Rexx), polled: ["res"]"
     INTERPRET res              /* interpret received text as a Rexx program    */
     if result= "SHUTDOWN, REXX !" then leave     /* JVM will be shutdown in 1/10sec      */
end
say "Now exiting Rexx."

